# information window
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import pango
import os

class info:

	# window closing
	def delete_event(self, widget, event, data=None):
		self.winInfo.destroy()

	# write program information
	def set_informations(self):
		descrizione = _("Pygeon is an instant messenger that supports xmpp protocol (Jabber).\n\nPygeon has the following functions:\n- Send broadcast\n- Send multiple messages\n- Chronology manager\n- Files transfer\n\n")
		sviluppatori = _("- Alessio Carminati (carminati@coopi.org)\n- Gianluca Signorotto (signorotto@coopi.org)\n\n")

		# empty textbox
		self.txtInfo.get_buffer().set_text("")

		# crete tags
		self.txtInfo.get_buffer().create_tag("title", weight = pango.WEIGHT_BOLD, size_points = 12, justification = gtk.JUSTIFY_CENTER)
		self.txtInfo.get_buffer().create_tag("description", size_points = 8)
		self.txtInfo.get_buffer().create_tag("bold", weight = pango.WEIGHT_BOLD, size_points = 8)
		self.txtInfo.get_buffer().create_tag("url", foreground = "blue", underline = pango.UNDERLINE_SINGLE, size_points = 8)

		# add text with tag
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), "Pygeon " + self.pygeon.program_version + "\n\n", "title")
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), descrizione, "description")
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), _("Website: "), "bold")
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), "http://gnu.coopi.org/pygeon\n\n", "url")
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), _("Developers\n\n"), "title")
		self.txtInfo.get_buffer().insert_with_tags_by_name(self.txtInfo.get_buffer().get_end_iter(), sviluppatori, "description")

	# click on url
	def txtInfo_clicked(self, widget, event):
		self.pygeon.url_clicked(self.txtInfo, event)

	# mouse move into textview
	def txtInfo_mouse_move(self, widget, event):
		self.pygeon.url_move_on(self.txtInfo, event)

	# constructor
	def __init__(self, pygeon):
		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winInfo")
		self.pygeon = pygeon # main class

		# glade objects
		self.winInfo = self.winContainer.get_widget("winInfo")
		self.imgLogo = self.winContainer.get_widget("imgLogo")
		self.txtInfo = self.winContainer.get_widget("txtInfo")

		# signals
		self.winInfo.connect("delete_event", self.delete_event)
		self.txtInfo.connect("button_press_event", self.txtInfo_clicked)
		self.txtInfo.connect("motion_notify_event", self.txtInfo_mouse_move)

		self.winInfo.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png"))
		self.imgLogo.set_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon.png"))
		self.winInfo.set_title(_("Pygeon - Information"))

		self.set_informations()
