# preferences window
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import os
import gobject
import base64

class pref:

	pygeon = None # main class
	avatar = ""
	languages = ['Deutsch', 'English', 'Español', 'Ελληνικά', 'Français', 'Italiano', 'Русский', 'Türkçe']
	themes = []

	# window closing
	def delete_event(self, widget, event, data=None):
		self.pygeon.pref_class = None # empty the class (this isn't used in the destroy signal)
		self.update_preferences()
		self.winPref.destroy()

	# click on close button
	def cmdClose_clicked(self, widget):
		self.pygeon.pref_class = None # empty the class (this isn't used in the destroy signal)
		self.update_preferences()
		self.winPref.destroy()
	
	# choose path for received files
	def cmdApri_clicked(self, widget):
		file = self.pygeon.file_chooser(_("Choose folder"), self.winPref, gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER)

		if file != "": self.txtApri.set_text(file)

	# choose receive sound
	def cmdRicevuto_clicked(self, widget):
		file = self.pygeon.file_chooser(_("Choose sound"), self.winPref, gtk.FILE_CHOOSER_ACTION_OPEN)

		if file != "": self.txtRicevuto.set_text(file)

	# play receive message sound
	def cmdRicevutoPlay_clicked(self, widget):
		if not self.pygeon.play_sound(self.txtRicevuto.get_text(), True):
			self.pygeon.message_box(_("Non playable file"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winPref)
			if self.pygeon.debug: print _("Non playable file")
	
	# play connection sound
	def cmdConnessoPlay_clicked(self, widget):
		if not self.pygeon.play_sound(self.txtConnesso.get_text(), True):
			self.pygeon.message_box(_("Non playable file"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winPref)
			if self.pygeon.debug: print _("Non playable file")
	
	# play disconnection sound
	def cmdDisconnessoPlay_clicked(self, widget):
		if not self.pygeon.play_sound(self.txtDisconnesso.get_text(), True):
			self.pygeon.message_box(_("Non playable file"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winPref)
			if self.pygeon.debug: print _("Non playable file")

	# choose path for sound
	def cmdConnesso_clicked(self, widget):
		file = self.pygeon.file_chooser(_("Choose sound"), self.winPref, gtk.FILE_CHOOSER_ACTION_OPEN)

		if file != "": self.txtConnesso.set_text(file)

	# choose path for sound
	def cmdDisconnesso_clicked(self, widget):
		file = self.pygeon.file_chooser(_("Choose sound"), self.winPref, gtk.FILE_CHOOSER_ACTION_OPEN)

		if file != "": self.txtDisconnesso.set_text(file)

	# enable/disable controls for receive
	def set_ricevuto_sensitive(self):
		if self.pygeon.mute:
			self.chkRicevuto.set_active(False)
			self.chkRicevuto.set_sensitive(False)

		self.txtRicevuto.set_sensitive(self.chkRicevuto.get_active())
		self.cmdRicevuto.set_sensitive(self.chkRicevuto.get_active())
		self.cmdRicevutoPlay.set_sensitive(self.chkRicevuto.get_active())

	# enable/disable controls for connect
	def set_connesso_sensitive(self):
		if self.pygeon.mute:
			self.chkConnesso.set_active(False)
			self.chkConnesso.set_sensitive(False)

		self.txtConnesso.set_sensitive(self.chkConnesso.get_active())
		self.cmdConnesso.set_sensitive(self.chkConnesso.get_active())
		self.cmdConnessoPlay.set_sensitive(self.chkConnesso.get_active())

	# enable/disable controls for disconnect
	def set_disconnesso_sensitive(self):
		if self.pygeon.mute:
			self.chkDisconnesso.set_active(False)
			self.chkDisconnesso.set_sensitive(False)

		self.txtDisconnesso.set_sensitive(self.chkDisconnesso.get_active())
		self.cmdDisconnesso.set_sensitive(self.chkDisconnesso.get_active())
		self.cmdDisconnessoPlay.set_sensitive(self.chkDisconnesso.get_active())

	# enable/disable controls for receive
	def chkRicevuto_toggled(self, widget):
		self.set_ricevuto_sensitive()
	
	# enable/disable controls for connect
	def chkConnesso_toggled(self, widget):
		self.set_connesso_sensitive()
	
	# enable/disable controls for disconnect
	def chkDisconnesso_toggled(self, widget):
		self.set_disconnesso_sensitive()

	# check avatar 'file'
	# return True if ok, False otherwise
	def check_avatar(self, file):
		try:
			ext = os.path.splitext(file)
			size = os.path.getsize(file)

			# jpeg or png image with maximum size of 20kb
			if (ext[1] == ".jpg" or ext[1] == ".jpeg" or ext[1] == ".png") and size <= 20480: return True
			else: return False
		except Exception:
			return False

	# add/remove avatar
	def cmdAvatar_clicked(self, widget):
		if self.avatar == os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"): # if there is no image
			file = self.pygeon.file_chooser(_("Choose avatar"), self.winPref, gtk.FILE_CHOOSER_ACTION_OPEN)

			if file != "" and os.path.isfile(file):
				# check if file is valid
				if self.check_avatar(file):
					self.load_avatar(file)
				else:
					self.pygeon.message_box(_("Invalid file. You can choose jpeg or png images with maximum size of 20KB"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winPref)
				
		else: # remove the image if present
			self.imgAvatar.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"))
			self.lblAvatar.set_text(_("Insert"))
			self.avatar = os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png")

	# load avatar if possible
	def load_avatar(self, filename):
		try:
			pix = gtk.gdk.pixbuf_new_from_file_at_size(filename, 100, 100)

			self.imgAvatar.set_from_pixbuf(pix)
			self.lblAvatar.set_text(_("Delete"))
			self.avatar = filename
		except gobject.GError:
			self.imgAvatar.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"))
			self.lblAvatar.set_text(_("Insert"))
			self.avatar = os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png")

	# load preferences from variables
	def read_preferences(self):
		# account
		self.txtName.set_text(self.pygeon.myname)
		self.txtUsername.set_text(self.pygeon.username)
		self.txtDomain.set_text(self.pygeon.domain)
		self.txtPassword.set_text(self.pygeon.password)
		self.txtServer.set_text(self.pygeon.server)
		self.txtPort.set_text(str(self.pygeon.port))
		self.chkConnetti.set_active(self.pygeon.autoconnect)
		self.load_avatar(os.path.normpath(self.pygeon.avatar))
		
		# files
		self.txtApri.set_text(self.pygeon.files_path)
		if self.pygeon.files_accept == 0: self.optAccetta.set_active(True)
		elif self.pygeon.files_accept == 1: self.optRifiuta.set_active(True)
		else: self.optChiedi.set_active(True)

		# sounds
		self.chkRicevuto.set_active(self.pygeon.sounds_receive)
		self.chkConnesso.set_active(self.pygeon.sounds_connect)
		self.chkDisconnesso.set_active(self.pygeon.sounds_disconnect)
		self.txtRicevuto.set_text(self.pygeon.sounds_receive_path)
		self.txtConnesso.set_text(self.pygeon.sounds_connect_path)
		self.txtDisconnesso.set_text(self.pygeon.sounds_disconnect_path)

		# notifications
		self.chkNotifyNormal.set_active(self.pygeon.notify_normal)
		self.chkNotifyChat.set_active(self.pygeon.notify_chat)
		self.chkNotifyConnect.set_active(self.pygeon.notify_connect)
		self.chkNotifyDisconnect.set_active(self.pygeon.notify_disconnect)
		self.chkNotifyStatus.set_active(self.pygeon.notify_status)
		self.chkNotifyAdd.set_active(self.pygeon.notify_add)
		self.chkNotifyRemove.set_active(self.pygeon.notify_remove)
		self.chkNotifyTransfer.set_active(self.pygeon.notify_transfer)

		# conversations
		if self.pygeon.conversations_save == 0: self.optSalvare.set_active(True)
		elif self.pygeon.conversations_save == 1: self.optNonsalvare.set_active(True)
		else: self.optConferma.set_active(True)
		self.chkPresent.set_active(self.pygeon.conversations_present)

		# language and theme
		self.cboLanguage.set_active(self.languages.index(self.pygeon.program_language))
		self.cboTheme.set_active(self.themes.index(self.pygeon.theme))

		if self.pygeon.debug: print _("Preferences loaded from variables")

	# save preferences into variables and into db
	def update_preferences(self):
		import xmpp

		# account
		# if the username changed set avatar_uploaded to False because it must be sent to server
		if self.pygeon.username != self.txtUsername.get_text().strip('\n '):
			self.pygeon.avatar_uploaded = False
			if self.pygeon.debug: print _("You changed username. At the next connection you must send the avatar to the server")

		self.pygeon.myname = self.txtName.get_text().strip('\n ')
		self.pygeon.username = self.txtUsername.get_text().strip('\n ')
		self.pygeon.domain = self.txtDomain.get_text().strip('\n ')
		self.pygeon.password = self.txtPassword.get_text().strip('\n ')
		self.pygeon.server = self.txtServer.get_text().strip('\n ')
		self.pygeon.port = self.txtPort.get_text().strip('\n ')
		self.pygeon.autoconnect = self.chkConnetti.get_active()

		if self.avatar != self.pygeon.avatar and not self.pygeon.client is None and self.pygeon.client.isConnected():
			if self.avatar == os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png") and self.pygeon.avatar == "":
				pass # if the image is empty doesn't send anything
			else:
				# if the file doesn't exist set the avatar no-image
				if not os.path.isfile(self.avatar):
					self.avatar = os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png")

				f = open(self.avatar, 'rb')
				stringa = f.read()
				codifica = base64.encodestring(stringa)
				f.close()

				# create the message
				iq = xmpp.protocol.Iq(typ = 'set')
				tag = iq.setTag("vcard-temp vCard")
				child = tag.addChild("PHOTO")
				child.addChild("TYPE").setData(self.pygeon.get_avatar_type(self.avatar))

				if self.avatar != os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"):
					child.addChild("BINVAL").setData(codifica)
				else:
					child.addChild("BINVAL")

				# send the avatar message to the server
				self.pygeon.client.send(iq)

				if self.pygeon.debug: print _("I sent the avatar to the server")

		# if there isn't the image it save empty in a variable waiting the ok from the server
		if self.avatar == os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"):
			self.pygeon.avatar_temp = ""
		else:
			self.pygeon.avatar_temp = self.avatar

		# files
		# save the path if it's correct
		if os.path.isdir(self.txtApri.get_text()):
			self.pygeon.files_path = self.txtApri.get_text()
		if self.optAccetta.get_active(): self.pygeon.files_accept = 0
		elif self.optRifiuta.get_active(): self.pygeon.files_accept = 1
		else: self.pygeon.files_accept = 2

		# sounds
		# save if it isn't in mute mode
		if not self.pygeon.mute:
			self.pygeon.sounds_receive = self.chkRicevuto.get_active()
			self.pygeon.sounds_connect = self.chkConnesso.get_active()
			self.pygeon.sounds_disconnect = self.chkDisconnesso.get_active()
			# save only if the paths are correct and the files are wav
			if os.path.isfile(self.txtRicevuto.get_text()) and self.txtRicevuto.get_text().endswith("wav"):
				self.pygeon.sounds_receive_path = self.txtRicevuto.get_text()

			if os.path.isfile(self.txtConnesso.get_text()) and self.txtConnesso.get_text().endswith("wav"):
				self.pygeon.sounds_connect_path = self.txtConnesso.get_text()

			if os.path.isfile(self.txtDisconnesso.get_text()) and self.txtDisconnesso.get_text().endswith("wav"):
				self.pygeon.sounds_disconnect_path = self.txtDisconnesso.get_text()

		# notifications
		self.pygeon.notify_normal = self.chkNotifyNormal.get_active()
		self.pygeon.notify_chat = self.chkNotifyChat.get_active()
		self.pygeon.notify_connect = self.chkNotifyConnect.get_active()
		self.pygeon.notify_disconnect = self.chkNotifyDisconnect.get_active()
		self.pygeon.notify_status = self.chkNotifyStatus.get_active()
		self.pygeon.notify_add = self.chkNotifyAdd.get_active()
		self.pygeon.notify_remove = self.chkNotifyRemove.get_active()
		self.pygeon.notify_transfer = self.chkNotifyTransfer.get_active()

		# conversations
		# save the path if it's correct
		if self.optSalvare.get_active(): self.pygeon.conversations_save = 0
		elif self.optNonsalvare.get_active(): self.pygeon.conversations_save = 1
		else: self.pygeon.conversations_save = 2
		self.pygeon.conversations_present = self.chkPresent.get_active()

		if self.cboLanguage.get_active_text() != self.pygeon.program_language:
			self.pygeon.program_language = self.cboLanguage.get_active_text()

			self.pygeon.message_box(_("The language has been modified. Restart the program to get the changes"), _("Modified language"), gtk.MESSAGE_INFO, gtk.BUTTONS_OK, self.winPref)
		
		if self.cboTheme.get_active_text() != self.pygeon.theme:
			self.pygeon.theme = self.cboTheme.get_active_text()

			self.pygeon.message_box(_("The theme has been modified. Restart the program to get the changes"), _("Modified theme"), gtk.MESSAGE_INFO, gtk.BUTTONS_OK, self.winPref)

		# save preferences to db
		self.pygeon.save_preferences()

		if self.pygeon.debug: print _("Preferences saved into variables")

	# constructor
	def __init__(self, pygeon):
		self.pygeon = pygeon # main class
		self.pygeon.pref_class = self

		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winPref", "pippo")

		# glade objects
		self.winPref = self.winContainer.get_widget("winPref")
		self.cmdClose = self.winContainer.get_widget("cmdClose")
		self.lblClose = self.winContainer.get_widget("lblClose")
		self.lblAccount = self.winContainer.get_widget("lblAccount")
		self.lblFiles = self.winContainer.get_widget("lblFiles")
		self.lblSounds = self.winContainer.get_widget("lblSounds")
		self.lblConversations = self.winContainer.get_widget("lblConversations")
		self.lblLanguages = self.winContainer.get_widget("lblLanguages")
		self.lblName = self.winContainer.get_widget("lblName")
		self.lblUsername = self.winContainer.get_widget("lblUsername")
		self.lblPassword = self.winContainer.get_widget("lblPassword")
		self.lblServer = self.winContainer.get_widget("lblServer")
		self.lblPort = self.winContainer.get_widget("lblPort")
		self.lblReceive = self.winContainer.get_widget("lblReceive")
		self.lblApriReceive = self.winContainer.get_widget("lblApriReceive")
		self.lblConnect = self.winContainer.get_widget("lblConnect")
		self.lblApriConnect = self.winContainer.get_widget("lblApriConnect")
		self.lblDisconnect = self.winContainer.get_widget("lblDisconnect")
		self.lblApriDisconnect = self.winContainer.get_widget("lblApriDisconnect")
		self.lblConversation = self.winContainer.get_widget("lblConversation")
		self.lblNotification = self.winContainer.get_widget("lblNotification")
		self.lblUseNotifications = self.winContainer.get_widget("lblUseNotifications")
		self.txtName = self.winContainer.get_widget("txtName")
		self.txtUsername = self.winContainer.get_widget("txtUsername")
		self.txtDomain = self.winContainer.get_widget("txtDomain")
		self.txtPassword = self.winContainer.get_widget("txtPassword")
		self.txtServer = self.winContainer.get_widget("txtServer")
		self.txtPort = self.winContainer.get_widget("txtPort")
		self.chkConnetti = self.winContainer.get_widget("chkConnetti")
		self.imgAvatar = self.winContainer.get_widget("imgAvatar")
		self.cmdAvatar = self.winContainer.get_widget("cmdAvatar")
		self.lblAvatar = self.winContainer.get_widget("lblAvatar")
		self.lblTitleAvatar = self.winContainer.get_widget("lblTitleAvatar")
		self.lblRicevuti = self.winContainer.get_widget("lblRicevuti")
		self.lblApriFile = self.winContainer.get_widget("lblApriFile")
		self.lblFileQuestion = self.winContainer.get_widget("lblFileQuestion")
		self.lblLanguage = self.winContainer.get_widget("lblLanguage")
		self.lblTheme = self.winContainer.get_widget("lblTheme")
		self.txtApri = self.winContainer.get_widget("txtApri")
		self.optAccetta = self.winContainer.get_widget("optAccetta")
		self.optRifiuta = self.winContainer.get_widget("optRifiuta")
		self.optChiedi = self.winContainer.get_widget("optChiedi")
		self.chkRicevuto = self.winContainer.get_widget("chkRicevuto")
		self.chkConnesso = self.winContainer.get_widget("chkConnesso")
		self.chkDisconnesso = self.winContainer.get_widget("chkDisconnesso")
		self.txtRicevuto = self.winContainer.get_widget("txtRicevuto")
		self.txtConnesso = self.winContainer.get_widget("txtConnesso")
		self.txtDisconnesso = self.winContainer.get_widget("txtDisconnesso")
		self.optSalvare = self.winContainer.get_widget("optSalvare")
		self.optNonsalvare = self.winContainer.get_widget("optNonsalvare")
		self.optConferma = self.winContainer.get_widget("optConferma")
		self.chkPresent = self.winContainer.get_widget("chkPresent")
		self.cmdApri = self.winContainer.get_widget("cmdApri")
		self.cmdRicevuto = self.winContainer.get_widget("cmdRicevuto")
		self.cmdConnesso = self.winContainer.get_widget("cmdConnesso")
		self.cmdDisconnesso = self.winContainer.get_widget("cmdDisconnesso")
		self.cmdRicevutoPlay = self.winContainer.get_widget("cmdRicevutoPlay")
		self.cmdConnessoPlay = self.winContainer.get_widget("cmdConnessoPlay")
		self.cmdDisconnessoPlay = self.winContainer.get_widget("cmdDisconnessoPlay")
		self.cboLanguage = self.winContainer.get_widget("cboLanguage")
		self.chkNotifyNormal = self.winContainer.get_widget("chkNotifyNormal")
		self.chkNotifyChat = self.winContainer.get_widget("chkNotifyChat")
		self.chkNotifyConnect = self.winContainer.get_widget("chkNotifyConnect")
		self.chkNotifyDisconnect = self.winContainer.get_widget("chkNotifyDisconnect")
		self.chkNotifyStatus = self.winContainer.get_widget("chkNotifyStatus")
		self.chkNotifyAdd = self.winContainer.get_widget("chkNotifyAdd")
		self.chkNotifyRemove = self.winContainer.get_widget("chkNotifyRemove")
		self.chkNotifyTransfer = self.winContainer.get_widget("chkNotifyTransfer")
		self.imgPrefClose = self.winContainer.get_widget("imgPrefClose")
		self.imgPrefOpen = self.winContainer.get_widget("imgPrefOpen")
		self.imgPrefReceived = self.winContainer.get_widget("imgPrefReceived")
		self.imgPrefConnected = self.winContainer.get_widget("imgPrefConnected")
		self.imgPrefDisconnected = self.winContainer.get_widget("imgPrefDisconnected")
		self.imgPrefPlayReceived = self.winContainer.get_widget("imgPrefPlayReceived")
		self.imgPrefPlayConnected = self.winContainer.get_widget("imgPrefPlayConnected")
		self.imgPrefPlayDisconnected = self.winContainer.get_widget("imgPrefPlayDisconnected")
		self.cboTheme = self.winContainer.get_widget("cboTheme")

		self.lblAccount.set_text(_("Account"))
		self.lblFiles.set_text(_("Files"))
		self.lblSounds.set_text(_("Sounds"))
		self.lblConversations.set_text(_("Conversations"))
		self.lblNotification.set_text(_("Notifications"))
		self.lblLanguages.set_text(_("Language&Theme"))
		self.lblClose.set_text(_("Close"))
		self.lblName.set_markup(_("<b>Fullname</b>"))
		self.lblUsername.set_markup(_("<b>Username</b>"))
		self.lblPassword.set_markup(_("<b>Password</b>"))
		self.lblServer.set_markup(_("<b>Server</b>"))
		self.lblPort.set_markup(_("<b>Port</b>"))
		self.lblTitleAvatar.set_markup(_("<b>Avatar</b>"))
		self.lblUseNotifications.set_markup(_("<b>Enable notifications when</b>"))
		self.chkConnetti.get_children()[0].set_label(_("Connect at the start up"))
		self.lblRicevuti.set_markup(_("<b>Folder of received files</b>"))
		self.lblApriFile.set_text(_("Browse"))
		self.lblFileQuestion.set_markup(_("<b>When a user tries to send you files</b>"))
		self.optAccetta.get_children()[0].set_label(_("Accept always"))
		self.optRifiuta.get_children()[0].set_label(_("Refuse always"))
		self.optChiedi.get_children()[0].set_label(_("Ask for confirmation"))
		self.lblReceive.set_markup(_("<b>Message received</b>"))
		self.lblConnect.set_markup(_("<b>User connected</b>"))
		self.lblDisconnect.set_markup(_("<b>User disconnected</b>"))
		self.lblApriReceive.set_text(_("Browse"))
		self.lblApriConnect.set_text(_("Browse"))
		self.lblApriDisconnect.set_text(_("Browse"))
		self.lblConversation.set_markup(_("<b>When you close the chat window</b>"))
		self.optSalvare.get_children()[0].set_label(_("Save the conversation"))
		self.optNonsalvare.get_children()[0].set_label(_("Don't save the conversation"))
		self.optConferma.get_children()[0].set_label(_("Ask for confirmation"))
		self.chkPresent.get_children()[0].set_label(_("Show window when you receive the first chat message"))
		self.lblLanguage.set_markup(_("<b>Select the preferred language</b>"))
		self.lblTheme.set_markup(_("<b>Select the theme</b>"))
		self.chkNotifyNormal.get_children()[0].set_label(_("you receive a message"))
		self.chkNotifyChat.get_children()[0].set_label(_("you receive a chat message"))
		self.chkNotifyConnect.get_children()[0].set_label(_("a contact connects"))
		self.chkNotifyDisconnect.get_children()[0].set_label(_("a contact disconnects"))
		self.chkNotifyStatus.get_children()[0].set_label(_("a contact change its status"))
		self.chkNotifyAdd.get_children()[0].set_label(_("a contact is added to the list"))
		self.chkNotifyRemove.get_children()[0].set_label(_("a contact is removed from the list"))
		self.chkNotifyTransfer.get_children()[0].set_label(_("send/receive files"))
		
		self.imgPrefClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))
		self.imgPrefOpen.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "open.png"))
		self.imgPrefReceived.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "open.png"))
		self.imgPrefConnected.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "open.png"))
		self.imgPrefDisconnected.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "open.png"))
		self.imgPrefPlayReceived.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "play.png"))
		self.imgPrefPlayConnected.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "play.png"))
		self.imgPrefPlayDisconnected.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "play.png"))

		store = gtk.ListStore(gobject.TYPE_STRING)
		self.cboTheme.set_model(store)
		cell_text = gtk.CellRendererText()
		self.cboTheme.pack_start(cell_text, True)
		self.cboTheme.add_attribute(cell_text, "text", 0)

		# load themes into theme select
		for theme in os.listdir(self.pygeon.current_path + "../data/images/themes"):
			store.append([theme])
			self.themes.append(theme)

		# signals
		self.winPref.connect("delete_event", self.delete_event)
		self.cmdClose.connect("clicked", self.cmdClose_clicked)
		self.cmdAvatar.connect("clicked", self.cmdAvatar_clicked)
		self.cmdApri.connect("clicked", self.cmdApri_clicked)
		self.cmdRicevuto.connect("clicked", self.cmdRicevuto_clicked)
		self.cmdRicevutoPlay.connect("clicked", self.cmdRicevutoPlay_clicked)
		self.cmdConnesso.connect("clicked", self.cmdConnesso_clicked)
		self.cmdConnessoPlay.connect("clicked", self.cmdConnessoPlay_clicked)
		self.cmdDisconnesso.connect("clicked", self.cmdDisconnesso_clicked)
		self.cmdDisconnessoPlay.connect("clicked", self.cmdDisconnessoPlay_clicked)
		self.chkRicevuto.connect("toggled", self.chkRicevuto_toggled)
		self.chkConnesso.connect("toggled", self.chkConnesso_toggled)
		self.chkDisconnesso.connect("toggled", self.chkDisconnesso_toggled)

		self.winPref.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png"))
		self.winPref.set_title(_("Pygeon - Preferences"))

		# load variables
		self.read_preferences()

		# set interface sensitive
		self.set_ricevuto_sensitive()
		self.set_connesso_sensitive()
		self.set_disconnesso_sensitive()

		# if the user isn't connected disable the avatar management
		if self.pygeon.client is None or not self.pygeon.client.isConnected(): self.cmdAvatar.set_sensitive(False)

		# if the user is connected disable the account objects
		if not self.pygeon.client is None and self.pygeon.client.isConnected():
			self.txtUsername.set_sensitive(False)
			self.txtDomain.set_sensitive(False)
			self.txtPassword.set_sensitive(False)
			self.txtServer.set_sensitive(False)
			self.txtPort.set_sensitive(False)
