# read message class
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import pango
import os
import datetime
import shutil

from send_message import send_message

class read_message:

	# load unread messages into the list
	# if 'utente' is specify load only the messages of 'utente'
	def load_messages(self, utente, type):
		cursor = self.pygeon.conn.cursor()

		if utente is None:
			cursor.execute("select date, with, subject, body, type, id from messages where type = " + str(type) + " order by id asc")
		else:
			cursor.execute("select date, with, subject, body, type, id from messages where type = " + str(type) + " and with like '" + utente + "%' order by id asc")

		self.messages = cursor.fetchall()
		cursor.close()

	# search for default message into the message list and move on its position
	def find_default(self, user, subject, body):
		self.current = 1
		found = False

		for message in self.messages:
			if user == self.pygeon.get_name_from_username(self.pygeon.fdb(message[1].partition('/')[0])) and subject == self.pygeon.fdb(message[2]) and body == self.pygeon.fdb(message[3]):
				self.read_message(self.current - 1)
				found = True
				break
		
			self.current += 1

		# if the message isn't found go on the first message
		if not found:
			self.cmdStart.clicked()

	# read the message 'number' into the message list
	def read_message(self, number):
		date = self.messages[number][0]
		user = self.pygeon.fdb(self.messages[number][1])
		subject = self.pygeon.fdb(self.messages[number][2])
		body = self.pygeon.fdb(self.messages[number][3])
		type = self.messages[number][4]
		id = self.messages[number][5]

		# message date
		if date.startswith(datetime.date.today().strftime("%d-%m-%Y")): self.lblTime.set_markup(_("<b>Date:</b> Today at ") + date.split(' ')[1])
		elif date.startswith((datetime.date.today() - datetime.timedelta(days=1)).strftime("%d-%m-%Y")): self.lblTime.set_markup(_("<b>Date:</b> Yesterday at ") + date.split(' ')[1])
		else: self.lblTime.set_markup(_("<b>Date:</b> ") + datetime.datetime.strptime(date, "%d-%m-%Y %H.%M.%S").strftime(_("%d-%m-%Y %H.%M.%S")))

		if self.type == 2 or self.type == 1: prefix = _("<b>From:</b> ")
		elif self.type == 0: prefix = _("<b>Recipient:</b> ")

		self.lblFrom.set_markup(prefix + self.pygeon.get_name_from_username(user.partition('/')[0]))
		self.lblSubject.set_markup(_("<b>Subject:</b> ") + subject)

		# message body (manage also quoted text)
		self.txtBody.get_buffer().set_text("") # empty the text field
		lines = body.split('\n') # get all lines
		for line in lines: # check for quoted text
			if line.startswith(">"): self.txtBody.get_buffer().insert_with_tags_by_name(self.txtBody.get_buffer().get_end_iter(), line + "\n", "quote")
			else: self.txtBody.get_buffer().insert_with_tags_by_name(self.txtBody.get_buffer().get_end_iter(), line + "\n", "normale")

		# map url to message
		self.pygeon.add_url_to_message(self.txtBody)

		# add emoticons to message
		self.pygeon.add_emoticons_to_message(self.txtBody)

		self.winRead.set_title(_("Message ") + str(self.current) + _(" of ") + str(len(self.messages)))

		# set the message to read if it's unread
		if type == 2:
			cursor = self.pygeon.conn.cursor()
			cursor.execute("update messages set type = 1 where id = " + str(id))
			self.pygeon.conn.commit()
			cursor.close()

			self.pygeon.remove_message_from_contact(user)

	# window closing
	def delete_event(self, widget, event, data=None):
		self.pygeon.read_message_classes.remove(self)
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.unload_emoticons() # clear emoticons list
		self.winRead.destroy()

	# click on close button
	def cmdClose_clicked(self, widget):
		self.pygeon.read_message_classes.remove(self)
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.unload_emoticons() # clear emoticons list
		self.winRead.destroy()

	# goto first message
	def cmdStart_clicked(self, widget):
		if self.current != 1:
			self.current = 1
			self.read_message(self.current - 1)

	# goto previous message
	def cmdBack_clicked(self, widget):
		if self.current > 1:
			self.current = self.current - 1
			self.read_message(self.current - 1)


	# goto next message
	def cmdNext_clicked(self, widget):
		if self.current < len(self.messages):
			self.current = self.current + 1
			self.read_message(self.current - 1)

	# delete the current message
	def cmdDelete_clicked(self, widget):
		cursor = self.pygeon.conn.cursor()
		cursor.execute("delete from messages where id = " + str(self.messages[self.current - 1][5]))
		self.pygeon.conn.commit()
		cursor.close()

		# remove element from the message list
		del self.messages[self.current - 1]

		# if the number of messages is 0 close the window
		if len(self.messages) == 0: self.cmdClose.clicked()
		else: # otherwise stay in the current position if possible
			if self.current > len(self.messages): # if it's the last message goto the previous message
				self.current = self.current - 1
				self.read_message(self.current - 1)
			else: # can remain in the current position
				self.read_message(self.current - 1)

	# goto last message
	def cmdEnd_clicked(self, widget):
		if self.current != len(self.messages):
			self.current = len(self.messages)
			self.read_message(self.current - 1)

	# open the send message window
	def cmdReply_clicked(self, widget):
		# if the user isn't connected deny the reply
		if self.pygeon.cboStatus.get_active() == 3 or not self.pygeon.client.isConnected():
			self.pygeon.message_box(_("You must be connected to reply to the message"), _("Warning"), gtk.MESSAGE_WARNING, gtk.BUTTONS_OK, self.winRead)
			return

		date = self.messages[self.current - 1][0]
		user = self.pygeon.fdb(self.messages[self.current - 1][1])
		subject = self.pygeon.fdb(self.messages[self.current - 1][2])
		body = self.pygeon.fdb(self.messages[self.current - 1][3])

		# call the send_message class
		self.pygeon.send_message_classes.append(send_message(self.pygeon, user, _("RE: ") + subject, body, date))
		
		# if there is 1 message close the window
		if len(self.messages) == 1: self.cmdClose.clicked()
	
	# click on url
	def txtBody_clicked(self, widget, event):
		self.pygeon.url_clicked(self.txtBody, event)
	
	# mouse move into textview
	def txtBody_mouse_move(self, widget, event):
		self.pygeon.url_move_on(self.txtBody, event)

	# constructor
	def __init__(self, pygeon, type, utente=None, default_user=None, default_subject=None, default_body=None):
		self.pygeon = pygeon # main class
		self.type = type # sent = 0, read = 1, unread = 2
		self.utente = utente

		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winRead")

		# glade object
		self.winRead = self.winContainer.get_widget("winRead")
		self.cmdClose = self.winContainer.get_widget("cmdReadClose")
		self.cmdStart = self.winContainer.get_widget("cmdStart")
		self.cmdBack = self.winContainer.get_widget("cmdBack")
		self.cmdNext = self.winContainer.get_widget("cmdNext")
		self.cmdEnd = self.winContainer.get_widget("cmdEnd")
		self.cmdDelete = self.winContainer.get_widget("cmdDelete")
		self.cmdReply = self.winContainer.get_widget("cmdReply")
		self.lblFrom = self.winContainer.get_widget("lblFrom")
		self.lblTime = self.winContainer.get_widget("lblTime")
		self.lblSubject = self.winContainer.get_widget("lblSubject")
		self.txtBody = self.winContainer.get_widget("txtBody")
		self.lblElimina = self.winContainer.get_widget("lblElimina")
		self.lblRispondi = self.winContainer.get_widget("lblRispondi")
		self.lblChiudi = self.winContainer.get_widget("lblChiudi")
		self.imgFirst = self.winContainer.get_widget("imgReadFirst")
		self.imgPrevious = self.winContainer.get_widget("imgReadPrevious")
		self.imgNext = self.winContainer.get_widget("imgReadNext")
		self.imgLast = self.winContainer.get_widget("imgReadLast")
		self.imgDelete = self.winContainer.get_widget("imgReadDelete")
		self.imgReply = self.winContainer.get_widget("imgReadReply")
		self.imgClose = self.winContainer.get_widget("imgReadClose")

		self.lblElimina.set_text(_("Delete"))
		self.lblRispondi.set_text(_("Reply"))
		self.lblChiudi.set_text(_("Close"))

		self.imgFirst.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "first.png"))
		self.imgPrevious.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "previous.png"))
		self.imgNext.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "next.png"))
		self.imgLast.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "last.png"))
		self.imgDelete.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "delete.png"))
		self.imgReply.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "message_big.png"))
		self.imgClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))

		# signals
		self.winRead.connect("delete_event", self.delete_event)
		self.cmdClose.connect("clicked", self.cmdClose_clicked)
		self.cmdStart.connect("clicked", self.cmdStart_clicked)
		self.cmdBack.connect("clicked", self.cmdBack_clicked)
		self.cmdNext.connect("clicked", self.cmdNext_clicked)
		self.cmdEnd.connect("clicked", self.cmdEnd_clicked)
		self.cmdDelete.connect("clicked", self.cmdDelete_clicked)
		self.cmdReply.connect("clicked", self.cmdReply_clicked)
		self.txtBody.connect("button_press_event", self.txtBody_clicked)
		self.txtBody.connect("motion_notify_event", self.txtBody_mouse_move)

		self.winRead.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png"))

		# if the type is sent hide the reply button
		if type == 0: self.cmdReply.hide()

		# create tags
		self.txtBody.get_buffer().create_tag("quote", foreground = "#888888")	
		self.txtBody.get_buffer().create_tag("url", foreground = "blue", underline = pango.UNDERLINE_SINGLE)
		self.txtBody.get_buffer().create_tag("normale")
		
		self.current = 0 # current message
		self.messages = None # messages list
		
		# load emoticons variable if unloaded
		if len(self.pygeon.read_message_classes) == 0 and len(self.pygeon.send_message_classes) == 0 and len(self.pygeon.crono_classes) == 0 and len(self.pygeon.chats) == 0: self.pygeon.load_emoticons()

		# load messages
		self.load_messages(utente, type)

		# if the type is unread goto first message if there aren't defaults, otherwise goto the message saved in defaults
		# if the type isn't unread goto last message
		if type == 2:
			if default_user is None or default_subject is None or default_body is None:
				self.cmdStart.clicked()
			else:
				self.find_default(default_user, default_subject, default_body)
		else: self.cmdEnd.clicked()
