# user information class
# coding: utf-8

##   Copyright (C) 2010 Coopi <gnu@coopi.org>
## 
##   This program is free software; you can redistribute it and/or
##   modify it under the terms of the GNU General Public License as
##   published by the Free Software Foundation; either version 2 of the
##   License, or (at your option) any later version.
## 
##   This program is distributed in the hope that it will be useful,
##   but WITHOUT ANY WARRANTY; without even the implied warranty of
##   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
##   General Public License for more details.
## 
##   You should have received a copy of the GNU General Public
##   License along with this program; if not, write to the
##   Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA

import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade
import os

class user_info:
	
	# window closing
	def delete_event(self, widget, event):
		self.winUserInfo.destroy()

	# click on close button
	def cmdClose_clicked(self, widget):
		self.winUserInfo.destroy()

	# constructor
	def __init__(self, pygeon, utente):
		self.pygeon = pygeon # main class
		name = self.pygeon.get_name_from_username(utente)

		self.gladefile = "../data/glade/pygeon.glade"
		self.winContainer = gtk.glade.XML(self.gladefile, "winUserInfo")

		# glade objects
		self.winUserInfo = self.winContainer.get_widget("winUserInfo")
		self.cmdClose = self.winContainer.get_widget("cmdInfoClose")
		self.imgAvatar = self.winContainer.get_widget("imgInfoAvatar")
		self.lblNome = self.winContainer.get_widget("lblInfoNome")
		self.lblStatus = self.winContainer.get_widget("lblInfoStatus")
		self.lblSeen = self.winContainer.get_widget("lblInfoSeen")
		self.lblStat = self.winContainer.get_widget("lblStat")
		self.lblUnread = self.winContainer.get_widget("lblInfoUnread")
		self.lblSent = self.winContainer.get_widget("lblInfoSent")
		self.lblRead = self.winContainer.get_widget("lblInfoRead")
		self.lblChat = self.winContainer.get_widget("lblInfoChat")
		self.lblUserinfoClose = self.winContainer.get_widget("lblUserinfoClose")
		self.imgClose = self.winContainer.get_widget("imgInfoClose")

		self.lblUserinfoClose.set_text(_("Close"))
		
		self.imgClose.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "close.png"))

		# signals
		self.winUserInfo.connect("delete_event", self.delete_event)
		self.cmdClose.connect("clicked", self.cmdClose_clicked)

		self.winUserInfo.set_icon_from_file(os.path.normpath(self.pygeon.icon_application_path + "pygeon-small.png")) # window icon
		self.winUserInfo.set_title(_("Information on ") + name)

		# load avatar if it exists, otherwise an alternative image
		if os.path.isfile(os.path.normpath(self.pygeon.pref_path + "/avatars/" + utente)):
			self.imgAvatar.set_from_file(os.path.normpath(self.pygeon.pref_path + "/avatars/" + utente))
		else:
			self.imgAvatar.set_from_file(os.path.normpath(self.pygeon.icon_theme_application_path + "no_avatar.png"))

		self.lblNome.set_markup(_("<small>Name: <b>") + name + _("</b></small>"))

		status = self.pygeon.get_user_status(utente)
		self.lblStatus.set_markup(_("<small>Current status: <b>") + self.pygeon.get_status_from_number(status) + _("</b></small>"))
		
		# check if show last_seen (only if user is offline)
		if status == 3:
			last_seen = self.pygeon.read_last_seen(utente)

			if not last_seen is None:
				self.lblSeen.set_markup("<small>" + last_seen[:last_seen.find(':')+1] + "<b>" + last_seen[last_seen.find(':')+1:] + "</b></small>")
			else:
				self.lblSeen.set_markup("")
		else:
			self.lblSeen.set_markup("")

		self.lblStat.set_markup(_("<b>Statistics</b>"))
		self.lblUnread.set_markup(_("<small>Unread messages: <b>") + str(self.pygeon.count_messages(2, utente)) + "</b></small>")
		self.lblSent.set_markup(_("<small>Sent messages: <b>") + str(self.pygeon.count_messages(0, utente)) + "</b></small>")
		self.lblRead.set_markup(_("<small>Received messages: <b>") + str(self.pygeon.count_messages(1, utente)) + "</b></small>")
		self.lblChat.set_markup(_("<small>Conversations: <b>") + str(self.pygeon.count_chats(utente)) + "</b></small>")
		
	# destructor
	def __del__(self):
		pass
